function [descriptors,pos] = get_descriptors2(fbr,ndescriptors,rrep,alpha,beta,rs,nthetas,ucm)

% function [descriptors,pos] = get_descriptors(fbr,ndescriptors,rrep,alpha,beta,rs,nthetas,M)
%

% Demo code for matching roughly based on the procedure
% described in:
%
% "Shape Matching and Object Recognition using Low Distortion Correspondence"
% A. C. Berg, T. L. Berg, J. Malik
% CVPR 2005
%
% code Copyright 2005 Alex Berg
%
% questions -> Alex Berg aberg@cs.berkeley.edu

[ii,jj] = find_interest_points(ucm,ndescriptors,rrep);

pos = [ii(:), jj(:)];

[descriptors sample_points]  = compute_gb(fbr,ii,jj,alpha,beta,rs,nthetas);

descriptors = normalize_descriptors(descriptors,rs,nthetas);
