% visualize bsds groundtruth
function vis_bsds_gtruth(fg_data, type)
   % compute correspondence for each image
   n_images = numel(fg_data);
   for n = 1:n_images
      % read image
      iid = fg_data(n).iid;
      im = imgRead(iid,'color');
      % load first segmentation with f/g annotations
      ind = find(fg_data(n).fg_count > 0);
      if (isempty(ind)), continue; end
      seg_file = fg_data(n).seg_files{ind};
      fg_file  = fg_data(n).fg_files{ind}; fg_file = fg_file{1};
      seg = readSeg(seg_file);
      fg  = readbin(fg_file);
      % extract segment and contour labels
      bmap = double(seg2bmap(seg));
      [cmap,cid2sid] = seg2cmap(seg,bmap);
      fg_im     = fg{1};
      fg_labels = fg{2};
      % thicken boundary of figure/ground image
      r = 3;
      has_fg = (fg_im ~= 0);
      [D L] = bwdist(has_fg);
      inds = find(D <= r);
      fg_im_new = zeros(size(fg_im));
      fg_im_new(inds) = fg_im(L(inds));
      fg_im = fg_im_new;
      % create color f/g boundary image
      fg_r = ones(size(fg_im));
      fg_g = ones(size(fg_im));
      fg_b = ones(size(fg_im));
      inds_figure = find(fg_im>0);
      inds_ground = find(fg_im<0);
      fg_g(inds_figure) = 0;
      fg_b(inds_figure) = 0;
      fg_r(inds_ground) = 0;
      fg_g(inds_ground) = 0;
      fg_vis = cat(3,fg_r,fg_g,fg_b);
      % write segmentation and figure/ground
      imwrite(im,['bsds_gtruth/' num2str(iid) '.png']);
      imwrite(1-bmap,['bsds_gtruth/' num2str(iid) '_bmap.png']);
      imwrite(fg_vis,['bsds_gtruth/' num2str(iid) '_fg.png']);
   end
end
